<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
class adminaccounts 
{
    protected $lang;
    protected $form_status;
    protected $form_message;
    protected $form_style;
    protected $user_list;
    protected $group_list;


    /*
     * Constructor -------------------------------------------------------------
     */
    public function adminaccounts($lang=array())
    {
        $this->lang = $lang;
        
        // handle delete account form.
        if( isset($_POST['deleteBtn']) )
        {
            $this->handleDeleteForm();
        }
        
        // handle update account form.
        if( isset($_POST['updateBtn']) )
        {
            $this->handleUpdateForm();
        }
        
        // load user list.
        $this->loadUserList();
        
        // load group list.
        $this->loadGroupList();
    }
    
    /*
     * Protected method: handle update account form ----------------------------
     * @return void.
     */
    protected function handleUpdateForm()
    {
        ( isset($_POST['idInput']) ? $id = trim($_POST['idInput']) : $id ='' );
        ( isset($_POST['groupInput']) ? $group = trim($_POST['groupInput']) :  $group = '' );
        ( isset($_POST['bannedInput']) ? $banned = trim($_POST['bannedInput']) : $banned = '' );
        ( isset($_POST['activatedInput']) ? $active = trim($_POST['activatedInput']) : $active = '' );
        
        $id = (int)$id;
        ( $banned == 'yes' ? $banned = '1' : $banned = '0' );
        ( $active == 'yes' ? $active = '1' : $active = '0' );
        
        // validate.
        if( $id < 1 )
        {
            $this->form_message = $this->lang['ACC_INVALID_ID_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        // update database.
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        $group = mysql_real_escape_string($group);
        
        if( !@mysql_query("UPDATE `register` SET `group`='$group', `banned`='$banned', `activated`='$active' WHERE `id`='$id' LIMIT 1;") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Unable to update user account at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['ACC_UPDATE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        $db->close();
        
        $this->form_message = $this->lang['ACC_UPDATE_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        return;
    }
    
    /*
     * Protected method: handle remove account form ----------------------------
     * @return void.
     */
    protected function handleDeleteForm()
    {
        $id = trim($_POST['idInput']);
        $id = (int)$id;
        
        if( $id < 1 )
        {
            $this->form_message = $this->lang['ACC_INVALID_ID_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        // remove account.
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        if( !@mysql_query("DELETE FROM `register` WHERE `id`='$id' LIMIT 1;") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Unable to remove user account at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['ACC_DELETE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        $db->close();
        
        $this->form_message = $this->lang['ACC_DELETE_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        return;
    }
    
    /*
     * Protected method: load group list ---------------------------------------
     * @return void.
     */
    protected function loadGroupList()
    {
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        $this->group_list = array();
        
        if( !$sql = @mysql_query("SELECT * FROM `group` ORDER BY `group` ASC") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Unable to load group list due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            // fail silently.
            return;
        }
        
        if( @mysql_num_rows($sql) > 0 )
        {
            while( $r = @mysql_fetch_assoc($sql) )
            {
                $obj = array(
                    'id' => $r['id'],
                    'group' => $r['group']
                );
                
                array_push($this->group_list, $obj);
            }
            
            @mysql_free_result($sql);
        }
        
        $db->close();
    }
    
    /*
     * Protected method: load user lsit ----------------------------------------
     * @return void.
     */
    protected function loadUserList()
    {
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        if( !$sql = @mysql_query("SELECT * FROM `register` ORDER BY `creation` ASC") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Unable to query register table at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            LogReport::fatalError($this->lang['ACC_LOAD_USERLIST_QUERY_ERROR']);
        }
        
        $this->user_list = array();
        
        if( @mysql_num_rows($sql) > 0 )
        {
            while( $r = @mysql_fetch_assoc($sql) )
            {
                $obj = array(
                    'id' => $r['id'],
                    'email' => $r['email'],
                    'name' => stripslashes($r['name']),
                    'group' => $r['group'],
                    'creation' => $r['creation'],
                    'banned' => (bool)$r['banned'],
                    'activated' => (bool)$r['activated']
                );
                
                array_push($this->user_list, $obj);
            }
            
            @mysql_free_result($sql);
        }
        
        $db->close();
    }
    
    /*
     * Public method: get group list -------------------------------------------
     * @return array.
     */
    public function getGroupList()
    {
        return $this->group_list;
    }
    
    /*
     * Public method: get user list --------------------------------------------
     * @return array.
     */
    public function getUserList()
    {
        return $this->user_list;
    }
    
    /*
     * Public method: get form status ------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }
    
    /*
     * Public method: get form message -----------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }
    
    /*
     * Public method: get form style -------------------------------------------
     * @return string.
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }
}

